[WXM] LeetCode 474. Ones and Zeroes C++

474. Ones and Zeroes

In the computer world, use restricted resource you have to generate maximum benefit is what we always want to pursue.

For now, suppose you are a dominator of m 0s and n 1s respectively. On the other hand, there is an array with strings consisting of only 0s and 1s.

Now your task is to find the maximum number of strings that you can form with given m 0s and n 1s. Each 0 and 1 can be used at most once.

Note:
The given numbers of 0s and 1s will both not exceed 100
The size of given string array won’t exceed 600.
Example 1:

Input: Array = {"10", "0001", "111001", "1", "0"}, m = 5, n = 3
Output: 4

Explanation: This are totally 4 strings can be formed by the using of 5 0s and 3 1s, which are “10,”0001”,”1”,”0

Example 2:

Input: Array = {"10", "0", "1"}, m = 1, n = 1
Output: 2

Explanation: You could form "10", but then you'd have nothing left. Better form "0" and "1".

Approach

  1. 题目大意是给你一定数量的零和一,然后问你能装下Array数组中最多的元素有多少个,不能重复。这道题很容易想到递推,因为它是变式题,与416. Partition Equal Subset Sum类型几乎是一样的,不过这里是二维,而那道题是一维,不过思想方法都一样,我们怎么递推呢,我们用dp[i][j] i表示此时零的数量,j表示此时一的数量 dp[i][j] 表示此时已装了的数量,所以可以得出递推公式 设某个字符串中有x个零,y个一 dp[i][j]=max(dp[i][j],dp[i+x][y+j]+1) 当然也可以换成这种 dp[i-x][j-y]=max(dp[i][j]+1,dp[i-x][j-y]),剩余看代码加深理解。
  2. [WXM] LeetCode 416. Partition Equal Subset Sum C++ 这道题与这道题是类似的

Code

class Solution {
public:
    int findMaxForm(vector<string>& strs, int m, int n) {
        int N = strs.size();
        vectorint, int>>res(N);
        for (int i = 0; i < N; i++) {
            int one = 0, zero = 0;
            for (int j = 0; j < strs[i].size(); j++) {
                if (strs[i][j] == '0')zero++;
                else one++;
            }
            res[i] = make_pair(zero, one);
        }
        vector<vector<int>>dp(m + 1, vector<int>(n + 1, -1));
        dp[m][n] = 0;
        int maxn = 0;
        for (int i = 0; i < N; i++) {
            for (int j = res[i].first; j <= m; j++) {
                for (int k = res[i].second; k <= n; k++) {
                    if (dp[j][k] >= 0) {
                        int nj = j - res[i].first, nk = k - res[i].second;
                        dp[nj][nk] = max(dp[j][k] + 1, dp[nj][nk]);
                        maxn = max(maxn, dp[nj][nk]);
                    }
                }
            }
        }
        return maxn;
    }
};

你可能感兴趣的:([WXM] LeetCode 474. Ones and Zeroes C++)